static const char *kvm_ioctl_cmds[] = {
	[0x00] = "GET_API_VERSION",
	[0x01] = "CREATE_VM",
	[0x02] = "GET_MSR_INDEX_LIST",
	[0x03] = "CHECK_EXTENSION",
	[0x04] = "GET_VCPU_MMAP_SIZE",
	[0x05] = "GET_SUPPORTED_CPUID",
	[0x09] = "GET_EMULATED_CPUID",
	[0x0a] = "GET_MSR_FEATURE_INDEX_LIST",
	[0x41] = "CREATE_VCPU",
	[0x42] = "GET_DIRTY_LOG",
	[0x44] = "SET_NR_MMU_PAGES",
	[0x45] = "GET_NR_MMU_PAGES",
	[0x46] = "SET_USER_MEMORY_REGION",
	[0x47] = "SET_TSS_ADDR",
	[0x48] = "SET_IDENTITY_MAP_ADDR",
	[0x60] = "CREATE_IRQCHIP",
	[0x61] = "IRQ_LINE",
	[0x62] = "GET_IRQCHIP",
	[0x63] = "SET_IRQCHIP",
	[0x64] = "CREATE_PIT",
	[0x65] = "GET_PIT",
	[0x66] = "SET_PIT",
	[0x67] = "IRQ_LINE_STATUS",
	[0x69] = "ASSIGN_PCI_DEVICE",
	[0x6a] = "SET_GSI_ROUTING",
	[0x70] = "ASSIGN_DEV_IRQ",
	[0x71] = "REINJECT_CONTROL",
	[0x72] = "DEASSIGN_PCI_DEVICE",
	[0x73] = "ASSIGN_SET_MSIX_NR",
	[0x74] = "ASSIGN_SET_MSIX_ENTRY",
	[0x75] = "DEASSIGN_DEV_IRQ",
	[0x76] = "IRQFD",
	[0x77] = "CREATE_PIT2",
	[0x78] = "SET_BOOT_CPU_ID",
	[0x79] = "IOEVENTFD",
	[0x7a] = "XEN_HVM_CONFIG",
	[0x7b] = "SET_CLOCK",
	[0x7c] = "GET_CLOCK",
	[0x80] = "RUN",
	[0x81] = "GET_REGS",
	[0x82] = "SET_REGS",
	[0x83] = "GET_SREGS",
	[0x84] = "SET_SREGS",
	[0x85] = "TRANSLATE",
	[0x86] = "INTERRUPT",
	[0x88] = "GET_MSRS",
	[0x89] = "SET_MSRS",
	[0x8a] = "SET_CPUID",
	[0x8b] = "SET_SIGNAL_MASK",
	[0x8c] = "GET_FPU",
	[0x8d] = "SET_FPU",
	[0x8e] = "GET_LAPIC",
	[0x8f] = "SET_LAPIC",
	[0x90] = "SET_CPUID2",
	[0x91] = "GET_CPUID2",
	[0x92] = "TPR_ACCESS_REPORTING",
	[0x93] = "SET_VAPIC_ADDR",
	[0x98] = "GET_MP_STATE",
	[0x99] = "SET_MP_STATE",
	[0x9a] = "NMI",
	[0x9b] = "SET_GUEST_DEBUG",
	[0x9c] = "X86_SETUP_MCE",
	[0x9d] = "X86_GET_MCE_CAP_SUPPORTED",
	[0x9e] = "X86_SET_MCE",
	[0x9f] = "GET_VCPU_EVENTS",
	[0xa0] = "SET_VCPU_EVENTS",
	[0xa3] = "ENABLE_CAP",
	[0xa4] = "ASSIGN_SET_INTX_MASK",
	[0xa5] = "SIGNAL_MSI",
	[0xa6] = "GET_XCRS",
	[0xa7] = "SET_XCRS",
	[0xa8] = "CREATE_SPAPR_TCE",
	[0xa9] = "ALLOCATE_RMA",
	[0xaa] = "DIRTY_TLB",
	[0xab] = "GET_ONE_REG",
	[0xac] = "SET_ONE_REG",
	[0xad] = "KVMCLOCK_CTRL",
	[0xb0] = "GET_REG_LIST",
	[0xb2] = "SET_PMU_EVENT_FILTER",
	[0xb7] = "SMI",
	[0xba] = "MEMORY_ENCRYPT_OP",
	[0xbb] = "MEMORY_ENCRYPT_REG_REGION",
	[0xbc] = "MEMORY_ENCRYPT_UNREG_REGION",
	[0xbd] = "HYPERV_EVENTFD",
	[0xbe] = "GET_NESTED_STATE",
	[0xbf] = "SET_NESTED_STATE",
	[0xc0] = "CLEAR_DIRTY_LOG",
	[0xc1] = "GET_SUPPORTED_HV_CPUID",
	[0xc6] = "X86_SET_MSR_FILTER",
	[0xc7] = "RESET_DIRTY_RINGS",
	[0xc8] = "XEN_HVM_GET_ATTR",
	[0xc9] = "XEN_HVM_SET_ATTR",
	[0xca] = "XEN_VCPU_GET_ATTR",
	[0xcb] = "XEN_VCPU_SET_ATTR",
	[0xcc] = "GET_SREGS2",
	[0xcd] = "SET_SREGS2",
	[0xce] = "GET_STATS_FD",
	[0xd0] = "XEN_HVM_EVTCHN_SEND",
	[0xe0] = "CREATE_DEVICE",
	[0xe1] = "SET_DEVICE_ATTR",
	[0xe2] = "GET_DEVICE_ATTR",
	[0xe3] = "HAS_DEVICE_ATTR",
};
